package com.engine.attendance.attendanceanalysis.service.impl;

import com.engine.attendance.attendanceanalysis.cmd.item.*;
import com.engine.attendance.attendanceanalysis.service.AbnormalAttendanceService;
import com.engine.attendance.enums.AccountingUnitEnum;
import com.engine.attendance.enums.ClassSegmentTypeEnum;
import com.engine.attendance.enums.WorkForTimeEnum;
import com.engine.common.util.DateUtil;
import com.engine.common.util.Utils;
import com.engine.core.impl.Service;
import com.google.common.collect.Lists;
import com.google.common.collect.Maps;
import weaver.general.Util;

import java.util.List;
import java.util.Map;

public class AbnormalAttendanceServiceImpl extends Service implements AbnormalAttendanceService {
    @Override
    public Map<String, Object> fullDayAbsenteeism(Map<String, Object> params) {


        return null;
    }

    @Override
    public List<Map<String,Object>> beLate(Map<String, Object> params) {
        //当前单条明细班次
        Map<String, Object> classInfo =  (Map<String, Object>)params.get("classInfo");
        //当前单个打卡数据
        Map<String,Object> clcokInTimeData = (Map<String, Object>)params.get("clcokInTimeData");
        //考勤项目
        List<Map<String,Object>> attendanceItems = (List<Map<String,Object>>)params.get("attendanceItems");
        //班段类型
        String bdlx = Util.null2String(classInfo.get("bdlx"));
        //分析日期
        String analysisDate = Util.null2String(params.get("analysisDate"));
        //人员
        String userId = Util.null2String(params.get("userId"));
        List<Map<String,Object>> resultList = Lists.newArrayList();

        String clockInTime = clcokInTimeData.get("signdate")+" "+clcokInTimeData.get("signtime");
        String classStartTime = analysisDate +" "+Util.null2String(classInfo.get("dtkssj"));
        int between = DateUtil.getBetWeenMinutes(classStartTime,clockInTime);

        Map<String,Object> lateParams = Maps.newHashMap();
        lateParams.put("attendanceItems",attendanceItems);
        lateParams.put("time",between);
        lateParams.put("rqlx",classInfo.get("rqlx"));


        if (ClassSegmentTypeEnum.WORK_TIME.getKey().equals(bdlx)){
            //工作时段
            lateParams.put("workfor",WorkForTimeEnum.WORK_TIME.getKey());
            Map<String,Object> result = commandExecutor.execute(new BeLateItemCmd(lateParams));
            List<Map<String,Object>> workTimeBeLateItems = (List<Map<String,Object>>)result.get("attendanceItems");
            if (workTimeBeLateItems.size() == 0){
                workTimeBeLateItems = (List<Map<String,Object>>)commandExecutor.execute(new AbsenteeismItemCmd(lateParams)).get("attendanceItems");
            }
            if (workTimeBeLateItems.size() > 0){
                Map<String,Object> saveWorkTimeBeLateParam = Maps.newHashMap();
                double hsl = Float.valueOf(Util.null2String(workTimeBeLateItems.get(0).get("hsl")));
                String hsdw = Util.null2String(workTimeBeLateItems.get(0).get("hsdw"));
                double itemduration = Utils.getItemduration(hsl,hsdw,between,AccountingUnitEnum.MINUTES);
//                saveWorkTimeBeLateParam.put("userId",userId);
//                saveWorkTimeBeLateParam.put("date",analysisDate);
                saveWorkTimeBeLateParam.put("item",workTimeBeLateItems.get(0).get("key"));
                saveWorkTimeBeLateParam.put("itemduration",itemduration);
                saveWorkTimeBeLateParam.put("betweenMinutes",between);
                resultList.add(saveWorkTimeBeLateParam);
//                List<Map<String,Object>> classInfoList = Lists.newArrayList();
//                classInfoList.add(classInfo);
//                saveWorkTimeBeLateParam.put("classInfo", classInfoList);
//                saveWorkTimeBeLateParam.put("cqzt","1");
//                commandExecutor.execute(new UpdateAttendanceResultsCmd(saveWorkTimeBeLateParam));
//                ifBeLate=true;
            }

        }else if (ClassSegmentTypeEnum.EXTENDED_OVERTIME.getKey().equals(bdlx) || ClassSegmentTypeEnum.EARLY_OVERTIME.getKey().equals(bdlx)
        || ClassSegmentTypeEnum.OVERTIME_PLAN.getKey().equals(bdlx)){
            //加班
            if (ClassSegmentTypeEnum.EXTENDED_OVERTIME.getKey().equals(bdlx)){
                lateParams.put("workfor",WorkForTimeEnum.DELAY_TO_WORK_OVERTIME.getKey());
            }else if (ClassSegmentTypeEnum.EARLY_OVERTIME.getKey().equals(bdlx)){
                lateParams.put("workfor",WorkForTimeEnum.EARLY_TO_WORK_OVERTIME.getKey());
            }else if (ClassSegmentTypeEnum.OVERTIME_PLAN.getKey().equals(bdlx)){
                lateParams.put("workfor",WorkForTimeEnum.PLAN_WORK_OVERTIME.getKey());
            }
            Map<String,Object> result = commandExecutor.execute(new WorkOvertimeItemCmd(lateParams));
            List<Map<String,Object>> workTimeBeLateItems = (List<Map<String,Object>>)result.get("attendanceItems");
            if (workTimeBeLateItems.size() > 0){
                double hsl = Float.valueOf(Util.null2String(workTimeBeLateItems.get(0).get("hsl")));
                String hsdw = Util.null2String(workTimeBeLateItems.get(0).get("hsdw"));
                String jbwdhlfzs = Util.null2String(workTimeBeLateItems.get(0).get("jbwdhlfzs"));
                if (!"".equals(jbwdhlfzs) && between > Integer.valueOf(jbwdhlfzs)){
                    Map<String,Object> saveWorkTimeBeLateParam = Maps.newHashMap();
                    double itemduration = Utils.getItemduration(hsl,hsdw,between,AccountingUnitEnum.MINUTES);
//                    saveWorkTimeBeLateParam.put("userId",userId);
//                    saveWorkTimeBeLateParam.put("date",analysisDate);
                    saveWorkTimeBeLateParam.put("item",getBeLateItems(lateParams).get(0).get("key"));
                    saveWorkTimeBeLateParam.put("itemduration",itemduration);
                    saveWorkTimeBeLateParam.put("betweenMinutes",between);
                    resultList.add(saveWorkTimeBeLateParam);
//                    List<Map<String,Object>> classInfoList = Lists.newArrayList();
//                    classInfoList.add(classInfo);
//                    saveWorkTimeBeLateParam.put("classInfo", classInfoList);
//                    saveWorkTimeBeLateParam.put("cqzt","1");
//                    commandExecutor.execute(new UpdateAttendanceResultsCmd(saveWorkTimeBeLateParam));
//                    ifBeLate=true;
                }
            }

        }else if (ClassSegmentTypeEnum.ASK_FOR_LEAVE.getKey().equals(bdlx) || ClassSegmentTypeEnum.EVECTION.getKey().equals(bdlx)){
            //请假、出差
            Map<String,Object> result = null;
            if (ClassSegmentTypeEnum.ASK_FOR_LEAVE.getKey().equals(bdlx)){
                lateParams.put("workfor",WorkForTimeEnum.WORK_TIME.getKey());
                result = commandExecutor.execute(new VacationItemCmd(lateParams));
            }else if (ClassSegmentTypeEnum.EVECTION.getKey().equals(bdlx)){
                lateParams.put("workfor",WorkForTimeEnum.WORK_TIME.getKey());
                result = commandExecutor.execute(new BeAwayItemCmd(lateParams));
            }
            List<Map<String,Object>> workTimeBeLateItems = (List<Map<String,Object>>)result.get("attendanceItems");
            double hsl = Float.valueOf(Util.null2String(workTimeBeLateItems.get(0).get("hsl")));
            String hsdw = Util.null2String(workTimeBeLateItems.get(0).get("hsdw"));
            String thfghlfzs = Util.null2String(workTimeBeLateItems.get(0).get("thfghlfzs"));
            if (!"".equals(thfghlfzs) &&  between> Integer.valueOf(thfghlfzs)){
                double itemduration = Utils.getItemduration(hsl,hsdw,between,AccountingUnitEnum.MINUTES);
                Map<String,Object> saveWorkTimeBeLateParam = Maps.newHashMap();
//                saveWorkTimeBeLateParam.put("userId",userId);
//                saveWorkTimeBeLateParam.put("date",analysisDate);
                saveWorkTimeBeLateParam.put("item",getBeLateItems(lateParams).get(0).get("key"));
                saveWorkTimeBeLateParam.put("itemduration",itemduration);
                saveWorkTimeBeLateParam.put("betweenMinutes",between);
                resultList.add(saveWorkTimeBeLateParam);
//                List<Map<String,Object>> classInfoList = Lists.newArrayList();
//                classInfoList.add(classInfo);
//                saveWorkTimeBeLateParam.put("classInfo", classInfoList);
//                saveWorkTimeBeLateParam.put("cqzt","1");
//                commandExecutor.execute(new UpdateAttendanceResultsCmd(saveWorkTimeBeLateParam));
//                ifBeLate=true;
            }
        }

        return resultList;
    }

    @Override
    public List<Map<String,Object>> leaveEarly(Map<String, Object> params) {
        //当前单条明细班次
        Map<String, Object> classInfo =  (Map<String, Object>)params.get("classInfo");
        //当前单个打卡数据
        Map<String,Object> clcokInTimeData = (Map<String, Object>)params.get("clcokInTimeData");
        //考勤项目
        List<Map<String,Object>> attendanceItems = (List<Map<String,Object>>)params.get("attendanceItems");
        //班段类型
        String bdlx = Util.null2String(classInfo.get("bdlx"));
        //分析日期
        String analysisDate = Util.null2String(params.get("analysisDate"));
        //人员
        String userId = Util.null2String(params.get("userId"));
        List<Map<String,Object>> resultList = Lists.newArrayList();

        String clockInTime = clcokInTimeData.get("signdate")+" "+clcokInTimeData.get("signtime");
        String dtkssj = analysisDate+" "+classInfo.get("dtkssj");
        String dtjssj = analysisDate+" "+classInfo.get("dtjssj");
        if (DateUtil.getTime(dtkssj).compareTo(DateUtil.getTime(dtjssj)) > 0){
            dtjssj = DateUtil.AfterDay(analysisDate,1) +" "+classInfo.get("dtjssj");
        }
        String classEndTime = dtjssj;
        int between = DateUtil.getBetWeenMinutes(clockInTime,classEndTime);

        Map<String,Object> earlyParams = Maps.newHashMap();
        earlyParams.put("attendanceItems",attendanceItems);
        earlyParams.put("time",between);
        earlyParams.put("rqlx",classInfo.get("rqlx"));

        boolean ifLeaveEarly = false;

        if (ClassSegmentTypeEnum.WORK_TIME.getKey().equals(bdlx)){
            //工作时段
            earlyParams.put("workfor",WorkForTimeEnum.WORK_TIME.getKey());
            Map<String,Object> result = commandExecutor.execute(new LeaveEarlyItemCmd(earlyParams));
            List<Map<String,Object>> workTimeBeLateItems = (List<Map<String,Object>>)result.get("attendanceItems");
            if (workTimeBeLateItems.size() == 0){
                workTimeBeLateItems = (List<Map<String,Object>>)commandExecutor.execute(new AbsenteeismItemCmd(earlyParams)).get("attendanceItems");
            }
            if (workTimeBeLateItems.size() > 0){
                Map<String,Object> saveWorkTimeBeLateParam = Maps.newHashMap();
                double hsl = Float.valueOf(Util.null2String(workTimeBeLateItems.get(0).get("hsl")));
                String hsdw = Util.null2String(workTimeBeLateItems.get(0).get("hsdw"));
                double itemduration = Utils.getItemduration(hsl,hsdw,between,AccountingUnitEnum.MINUTES);
//                saveWorkTimeBeLateParam.put("userId",userId);
//                saveWorkTimeBeLateParam.put("date",analysisDate);
                saveWorkTimeBeLateParam.put("item",getBeEarlyItems(earlyParams).get(0).get("key"));
                saveWorkTimeBeLateParam.put("itemduration",itemduration);
                saveWorkTimeBeLateParam.put("betweenMinutes",between);
                resultList.add(saveWorkTimeBeLateParam);
//                List<Map<String,Object>> classInfoList = Lists.newArrayList();
//                classInfoList.add(classInfo);
//                saveWorkTimeBeLateParam.put("classInfo", classInfoList);
//                saveWorkTimeBeLateParam.put("cqzt","1");
//                commandExecutor.execute(new UpdateAttendanceResultsCmd(saveWorkTimeBeLateParam));
//                ifLeaveEarly=true;
            }

        }else if (ClassSegmentTypeEnum.EXTENDED_OVERTIME.getKey().equals(bdlx) || ClassSegmentTypeEnum.EARLY_OVERTIME.getKey().equals(bdlx)
                || ClassSegmentTypeEnum.OVERTIME_PLAN.getKey().equals(bdlx)){
            //加班
            if (ClassSegmentTypeEnum.EXTENDED_OVERTIME.getKey().equals(bdlx)){
                earlyParams.put("workfor",WorkForTimeEnum.DELAY_TO_WORK_OVERTIME.getKey());
            }else if (ClassSegmentTypeEnum.EARLY_OVERTIME.getKey().equals(bdlx)){
                earlyParams.put("workfor",WorkForTimeEnum.EARLY_TO_WORK_OVERTIME.getKey());
            }else if (ClassSegmentTypeEnum.OVERTIME_PLAN.getKey().equals(bdlx)){
                earlyParams.put("workfor",WorkForTimeEnum.PLAN_WORK_OVERTIME.getKey());
            }
            Map<String,Object> result = commandExecutor.execute(new WorkOvertimeItemCmd(earlyParams));
            List<Map<String,Object>> workTimeBeLateItems = (List<Map<String,Object>>)result.get("attendanceItems");
            if (workTimeBeLateItems.size() > 0){
                double hsl = Float.valueOf(Util.null2String(workTimeBeLateItems.get(0).get("hsl")));
                String hsdw = Util.null2String(workTimeBeLateItems.get(0).get("hsdw"));
                String jbzzhlfzs = Util.null2String(workTimeBeLateItems.get(0).get("jbzzhlfzs"));
                if (!"".equals(jbzzhlfzs) && between > Integer.valueOf(jbzzhlfzs)){
                    Map<String,Object> saveWorkTimeBeLateParam = Maps.newHashMap();
                    double itemduration = Utils.getItemduration(hsl,hsdw,between,AccountingUnitEnum.MINUTES);


//                    saveWorkTimeBeLateParam.put("userId",userId);
//                    saveWorkTimeBeLateParam.put("date",analysisDate);
                    saveWorkTimeBeLateParam.put("item",getBeEarlyItems(earlyParams).get(0).get("key"));
                    saveWorkTimeBeLateParam.put("itemduration",itemduration);
                    saveWorkTimeBeLateParam.put("betweenMinutes",between);
                    resultList.add(saveWorkTimeBeLateParam);
//                    List<Map<String,Object>> classInfoList = Lists.newArrayList();
//                    classInfoList.add(classInfo);
//                    saveWorkTimeBeLateParam.put("classInfo", classInfoList);
//                    saveWorkTimeBeLateParam.put("cqzt","1");
//                    commandExecutor.execute(new UpdateAttendanceResultsCmd(saveWorkTimeBeLateParam));
//                    ifLeaveEarly=true;
                }
            }

        }else if (ClassSegmentTypeEnum.ASK_FOR_LEAVE.getKey().equals(bdlx) || ClassSegmentTypeEnum.EVECTION.getKey().equals(bdlx)){
            //请假、出差
            Map<String,Object> result = null;
            if (ClassSegmentTypeEnum.ASK_FOR_LEAVE.getKey().equals(bdlx)){
                earlyParams.put("workfor",WorkForTimeEnum.WORK_TIME.getKey());
                result = commandExecutor.execute(new VacationItemCmd(earlyParams));
            }else if (ClassSegmentTypeEnum.EVECTION.getKey().equals(bdlx)){
                earlyParams.put("workfor",WorkForTimeEnum.WORK_TIME.getKey());
                result = commandExecutor.execute(new BeAwayItemCmd(earlyParams));
            }
            List<Map<String,Object>> workTimeBeLateItems = (List<Map<String,Object>>)result.get("attendanceItems");
            double hsl = Float.valueOf(Util.null2String(workTimeBeLateItems.get(0).get("hsl")));
            String hsdw = Util.null2String(workTimeBeLateItems.get(0).get("hsdw"));
            String tqlghlfzs = Util.null2String(workTimeBeLateItems.get(0).get("tqlghlfzs"));
            if (!"".equals(tqlghlfzs) &&  between> Integer.valueOf(tqlghlfzs)){
                double itemduration = Utils.getItemduration(hsl,hsdw,between,AccountingUnitEnum.MINUTES);
                Map<String,Object> saveWorkTimeBeLateParam = Maps.newHashMap();
//                saveWorkTimeBeLateParam.put("userId",userId);
//                saveWorkTimeBeLateParam.put("date",analysisDate);
                saveWorkTimeBeLateParam.put("item",getBeEarlyItems(earlyParams).get(0).get("key"));
                saveWorkTimeBeLateParam.put("itemduration",itemduration);
                saveWorkTimeBeLateParam.put("betweenMinutes",between);
                resultList.add(saveWorkTimeBeLateParam);
//                List<Map<String,Object>> classInfoList = Lists.newArrayList();
//                classInfoList.add(classInfo);
//                saveWorkTimeBeLateParam.put("classInfo", classInfoList);
//                saveWorkTimeBeLateParam.put("cqzt","1");
//                commandExecutor.execute(new UpdateAttendanceResultsCmd(saveWorkTimeBeLateParam));
//                ifLeaveEarly=true;
            }
        }

        return resultList;
    }

    /**
     * 获得迟到项目
     * @return
     */
    public List<Map<String,Object>> getBeLateItems(Map<String,Object> lateParams){
        Map<String,Object> result = commandExecutor.execute(new BeLateItemCmd(lateParams));
        List<Map<String,Object>> workTimeBeLateItems = (List<Map<String,Object>>)result.get("attendanceItems");
        if (workTimeBeLateItems.size() == 0){
            workTimeBeLateItems = (List<Map<String,Object>>)commandExecutor.execute(new AbsenteeismItemCmd(lateParams)).get("attendanceItems");
        }
        return workTimeBeLateItems;
    }
    /**
     * 获得早退项目
     * @return
     */
    public List<Map<String,Object>> getBeEarlyItems(Map<String,Object> earlyParams){
        Map<String,Object> result = commandExecutor.execute(new LeaveEarlyItemCmd(earlyParams));
        List<Map<String,Object>> workTimeBeLateItems = (List<Map<String,Object>>)result.get("attendanceItems");
        if (workTimeBeLateItems.size() == 0){
            workTimeBeLateItems = (List<Map<String,Object>>)commandExecutor.execute(new AbsenteeismItemCmd(earlyParams)).get("attendanceItems");
        }
        return workTimeBeLateItems;
    }

}
