package com.engine.attendance.attendanceanalysis.service.impl;

import com.engine.attendance.attendanceanalysis.service.AskForLeaveService;
import com.engine.attendance.enums.CheckBoxEnum;
import com.engine.common.util.DateUtil;
import com.engine.core.impl.Service;
import com.google.common.collect.Lists;
import weaver.general.Util;

import java.util.Comparator;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

public class AskForLeaveServiceImpl extends Service implements AskForLeaveService {

    @Override
    public List<Map<String,Object>> askForLeaveByTime(Map<String, Object> param) {
        //人员迟到、早退、漏卡等记录
        List<Map<String,Object>> abnormalClockInList = (List<Map<String,Object>>)param.get("abnormalClockInList");
        //请假开始时间
        String kssj = Util.null2String(param.get("kssj"));
        //请假结束时间
        String jssj = Util.null2String(param.get("jssj"));

        List<Map<String,Object>> needRemoveList = Lists.newArrayList();
        for (int i=0;i<abnormalClockInList.size();i++){
            String pointTime = Util.null2String(abnormalClockInList.get(i).get("pointTime"));
            if (DateUtil.getTime(kssj).compareTo(DateUtil.getTime(pointTime)) <=0 &&
                    DateUtil.getTime(jssj).compareTo(DateUtil.getTime(pointTime)) >=0){
                needRemoveList.add(abnormalClockInList.get(i));
            }
        }
        abnormalClockInList.removeAll(needRemoveList);
        return abnormalClockInList;
    }

    @Override
    public boolean askForLeaveByHalfDay(Map<String, Object> param) {
        return false;
    }

    @Override
    public List<Map<String,Object>> askForLeaveByDurationTime(Map<String, Object> param) {
        //人员迟到、早退、漏卡等记录
        List<Map<String,Object>> abnormalClockInList = (List<Map<String,Object>>)param.get("abnormalClockInList");
        List<Map<String,Object>> forgetClockList = abnormalClockInList.stream().filter(e -> e.get("betweenMinutes") == null).collect(Collectors.toList());
        abnormalClockInList = abnormalClockInList.stream().filter(e -> e.get("betweenMinutes") != null).collect(Collectors.toList());
        abnormalClockInList = abnormalClockInList.stream().sorted(Comparator.comparing(e->Integer.valueOf(e.get("betweenMinutes").toString()))).collect(Collectors.toList());

        //请假时长,单位小时
        int qjsc = param.get("qjsc") == null?0:Double.valueOf(Double.valueOf(param.get("qjsc").toString())*60).intValue();
        //同一天可抵消多个异常
        String tybcndbjlhbjs = Util.null2String(param.get("tybcndbjlhbjs"));
        List<Map<String,Object>> needRemoveList = Lists.newArrayList();
        if (CheckBoxEnum.CHECKED.getKey().equals(tybcndbjlhbjs)){
            for (int i=abnormalClockInList.size() -1;i>=0;i--){
                int time = Integer.valueOf(abnormalClockInList.get(i).get("betweenMinutes").toString());
                if (qjsc >= time){
                    qjsc = qjsc-time;
                    needRemoveList.add(abnormalClockInList.get(i));
                }
            }
            abnormalClockInList.removeAll(needRemoveList);
        }else{
            for (int i=abnormalClockInList.size() -1;i>=0;i--){
                int time = Integer.valueOf(abnormalClockInList.get(i).get("betweenMinutes").toString());
                if (qjsc >= time){
                    abnormalClockInList.remove(i);
                    break;
                }
            }
        }
        abnormalClockInList.addAll(forgetClockList);

        return abnormalClockInList;
    }
}

